#!/bin/sh

./lib/dracut-lib.sh
setdebug

while [ 1 ]; do
    if [ -n "$root" -a -z "${root%%block:*}" ]; then
        rootdev=$(readlink -f "${root#block:}")
        rootdev=$(echo $rootdev | sed 's/\/dev\///g')
        devprefix=$(echo $rootdev | sed 's/-[a-z]*[0-9]*//g')
        if [ "$devprefix" = "nytro" ]; then
            echo "rootdev is nytro $rootdev" | vinfo
            break
        fi

        rootdevwhole=$(echo $rootdev | sed 's/[0-9]//g')
        if [ -e /sys/block/$rootdevwhole/device/vendor ]; then
            vendor=$(cat /sys/block/$rootdevwhole/device/vendor)
            vendor=$(echo $vendor | sed 's/\ //g')
            if [ "$vendor" != "SEAGATE" ]; then
                echo "root dev $rootdev's vendor $vendor is not SEAGATE" | vinfo
                break
            fi
            echo "root dev $rootdev's vendor is $vendor" | vinfo
        fi

        if [ -e /sys/block/$rootdevwhole/device/model ]; then
            model=$(cat /sys/block/$rootdevwhole/device/model)
            model=$(echo $model | sed 's/\ //g')
            model=$(echo $model | sed 's/[0-9]*//g')
            if [ "$model" != "NytroXP" -a "$model" != "NytroXH" ]; then
                echo "root dev $rootdev's model $model is not NytroXP/NytroXH" | vinfo
                break
            fi
            echo "root dev $rootdev's model is $model" | vinfo
        fi

        rootdev=$(echo "nytro-$rootdev")
        rootdevfound=0
        loop=0
        loopmax=30
        while [ $rootdevfound -eq 0 -a $loop -lt $loopmax ]; do
            for nytro in /dev/disk/by-uuid/*; do
                if [ -e "$nytro" ]; then
                    dev=$(readlink -f $nytro)
                    dev=$(echo $dev | sed 's/\/dev\///g')
                    if [ "$dev" = "$rootdev" ]; then
                        rootdevfound=1
                        break
                    fi
                fi
            done
            loop=$(($loop+1))
            # sleep for 0.1 seconds
            sleep 0.1
            udevsettle
        done
        if [ $rootdevfound -eq 0 ]; then
            echo "root device $rootdev not yet deteted by udev. waitcnt $loop" | vinfo
        else
            echo "udev detected root device $rootdev" | vinfo
        fi
    fi
    break
done
